//
//  NEXReachability.h
//  NumberEightCompiled
//
//  Created by Oliver Kocsis on 21/06/2018.
//  Copyright © 2018 NumberEight Technologies Ltd. All rights reserved.
//
#pragma once

#import "NEReachability.h"
#import "NEXSensorItem.h"

NS_ASSUME_NONNULL_BEGIN

/**
 * Represents the reachability of the device's radios: cellular and Wifi.
 *
 * This does not guarantee that the user has network access, but rather whether
 * the device has service.
 */
@interface NEXReachability : NEXSensorItem

/**
 * Default constructor.
 */
- (instancetype)init;

/**
 * Default constructor.
 */
+ (instancetype)new;

/**
 * Conversion copy constructor.
 * @param reachability NEReachability to copy from.
 */
- (instancetype)initWithReachability:(NEReachability)reachability;

/**
 * Conversion copy constructor.
 * @param reachability NEReachability to copy from.
 * @param confidence An optional confidence level from 0.0 (min) to 1.0 (max).
 */
- (instancetype)initWithReachability:(NEReachability)reachability confidence:(double)confidence;

/**
 * @param cellState Cellular telephony signal state.
 * @param cellDataState Cellular data service state.
 * @param wifiState Wifi service state.
 * @param flags Connection quality flags:
 * - NEReachabilityFlagHasInternet -
 *          An active and working Internet connection exists.
 * - NEReachabilityFlagSlowConnection -
 *          Internet connection has a slow data rate,
 *          i.e. only suitable for text/email transfers.
 * - NEReachabilityFlagIsMetered -
 *          Internet connection is limited or billed by usage.
 *          Data usage should be light and infrequent when this flag is true.
 */
- (instancetype)initWithCellState:(NEReachabilityCellState)cellState
                    cellDataState:(NEReachabilityCellDataState)cellDataState
                        wifiState:(NEReachabilityWifiState)wifiState
                            flags:(NEReachabilityFlags)flags;

/**
 * @param cellState Cellular telephony signal state.
 * @param cellDataState Cellular data service state.
 * @param wifiState Wifi service state.
 * @param flags Connection quality flags:
 * - NEReachabilityFlagHasInternet -
 *          An active and working Internet connection exists.
 * - NEReachabilityFlagSlowConnection -
 *          Internet connection has a slow data rate,
 *          i.e. only suitable for text/email transfers.
 * - NEReachabilityFlagIsMetered -
 *          Internet connection is limited or billed by usage.
 *          Data usage should be light and infrequent when this flag is true.
 * @param confidence An optional confidence level from 0.0 (min) to 1.0 (max).
 */
- (instancetype)initWithCellState:(NEReachabilityCellState)cellState
                    cellDataState:(NEReachabilityCellDataState)cellDataState
                        wifiState:(NEReachabilityWifiState)wifiState
                            flags:(NEReachabilityFlags)flags
                       confidence:(double)confidence;

/**
 * Parse a string in serialized form.
 * @param string The serialized string, as generated by serialize()
 *
 * @return `nil` if unserialization failed.
 */
+ (instancetype _Nullable)unserializeWithString:(NSString*)string;

@property(nonatomic, readonly) NEReachability value DEPRECATED_ATTRIBUTE;

/**
 * The reachability status of the device's voice-only cellular radios.
 */
@property(nonatomic, readwrite) NEReachabilityCellState cellState;

/**
 * @return `true` if the cell state is not Off or Unknown.
 */
- (bool)isCellStateOn;

/**
 * The reachability status of the device's cellular data service.
 */
@property(nonatomic, readwrite) NEReachabilityCellDataState cellDataState;

/**
 * @return `true` if the cell data state is not Off or Unknown.
 */
- (bool)isCellDataStateOn;

/**
 * The reachability status of the device's Wifi radios.
 */
@property(nonatomic, readwrite) NEReachabilityWifiState wifiState;

/**
 * @return `true` if the wifi state is not Off or Unknown.
 */
- (bool)isWifiStateOn;

/**
 * Flags indicating connection quality:
 * - NEReachabilityFlagHasInternet -
 *          An active and working Internet connection exists.
 * - NEReachabilityFlagSlowConnection -
 *          Internet connection has a slow data rate,
 *          i.e. only suitable for text/email transfers.
 * - NEReachabilityFlagIsMetered -
 *          Internet connection is limited or billed by usage.
 *          Data usage should be light and infrequent when this flag is true.
 */
@property(nonatomic, readwrite) NEReachabilityFlags flags;

/**
 * Convenience getter for hasInternet() && !isSlow().
 *
 * @return `true` if Internet connection exists, and is suitable for most applications,
 *          e.g. browsing the web or downloading images.
 */
- (bool)isGood;

/**
 * @return `true` if an active and working Internet connection exists.
 */
- (bool)hasInternet;

/**
 * @return `true` if Internet connection has a slow data rate,
 *          i.e. only suitable for text/email transfers.
 */
- (bool)isSlow;

/**
 * @return `true` if Internet connection is limited or billed by usage.
 *          Data usage should be light and infrequent when this flag is true.
 */
- (bool)isMetered;

/**
 * @return A hash value representing the state of the Type.
 *          Can be used for checking equality.
 */
@property(nonatomic, readonly) NSUInteger hash;

/**
 * @return The name of the concrete value class extending NEXSensorItem.
 */
@property(nonatomic, readonly) NSString* type;

/**
 * @return A human-readable format of the held data.
 */
@property(nonatomic, readonly) NSString* description;

/**
 * @return A machine-readable format of the held data.  Returns `nil` if @p type is invalid, or if
 * serialization failed.
 */
- (NSString* _Nullable)serialize;

/**
 * Strict equality comparison.
 *
 * @see NEReachability_isEqual
 *
 * @param object Value to compare with.
 */
- (BOOL)isEqual:(id _Nullable)object;

/**
 * Convert the Objective-C class to a C-compatible struct.
 */
- (NEReachability)c_val;

@end
NS_ASSUME_NONNULL_END
